
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《Spark 官方文档》在Mesos上运行Spark / iVAN</title>

    <meta name="description" content="《Spark 官方文档》在Mesos上运行Spark 在Mesos上运行Spark Spark可以在由Apache Mesos 管理的硬件集群中运行. 在Mesos集群中使用Spark的主要优势有: 可以在Spark以及其他框架(frameworks)之间动态划分资源. 可以同时部署多个Spark实例,且各个实例间的资源分配可以调整. 工作原理 在独立部署的Spark集群中,下图里的Cluster Manager代表Spark master.然而,在Mesos集群中,Mesos master将取代Spark master在下图中的地位. 如果一个S">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《Spark 官方文档》在Mesos上运行Spark</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1>在Mesos上运行Spark</h1>
<p>Spark可以在由<a href="http://mesos.apache.org/" rel="external nofollow noreferrer">Apache Mesos</a> 管理的硬件集群中运行。</p>
<p>在Mesos集群中使用Spark的主要优势有：</p>
<ul>
<li>可以在Spark以及其他框架（<a href="https://mesos.apache.org/documentation/latest/mesos-frameworks/" rel="external nofollow noreferrer">frameworks</a>）之间动态划分资源。</li>
<li>可以同时部署多个Spark实例，且各个实例间的资源分配可以调整。</li>
</ul>
<h1>工作原理</h1>
<p>在独立部署的Spark集群中，下图里的Cluster Manager代表Spark master。然而，在Mesos集群中，Mesos master将取代Spark master在下图中的地位。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3BhcmsuYXBhY2hlLm9yZy9kb2NzL2xhdGVzdC9pbWcvY2x1c3Rlci1vdmVydmlldy5wbmc=.jpg"></p>
<p>如果一个Spark驱动程序（driver）提交一个作业（job）并开始分发调度作业相关的任务（task），将会由Mesos来决定每个任务分发到哪台机器上。Mesos在调度短期任务的时候，会根据提交任务的账号来动态分配资源，而不需要依赖于静态的资源划分。</p>
<p>按以下所示的步骤，来安装Mesos，以及向Mesos提交Spark作业。</p>
<h1>安装Mesos</h1>
<p>Spark 1.6.0使用Mesos 0.21.0的时候，不需要任何特殊的Mesos补丁包。</p>
<p>如果你已经有一个Mesos集群，可以忽略Mesos安装这一步。</p>
<p>为Spark安装的Mesos和你为其他框架安装的Mesos没有什么不同。既可以从源代码安装，也可以从预编译好的包安装。</p>
<h2>使用源代码安装</h2>
<p>按以下步骤可以使用源代码安装Apache Mesos：</p>
<ol>
<li>从镜像（<a href="http://www.apache.org/dyn/closer.lua/mesos/0.21.0/" rel="external nofollow noreferrer">mirror</a>）下载一个Mesos发布版本</li>
<li>按Mesos的开始页（<a href="http://mesos.apache.org/gettingstarted" rel="external nofollow noreferrer">Getting Started</a>）所示的步骤来编译和安装Mesos</li>
</ol>
<p>注意：如果你不想把Mesos安装到系统默认路径下（比如，你没有管理员权限），可以通过configure脚本的–prefix参数来指定安装路径，例如，configure –prefix=/home/me/mesos。默认的安装路径是/usr/local。</p>
<h2>使用第三方包安装</h2>
<p>Apache Mesos项目本身只发布源码包，但你可以从一些第三方项目中找到Mesos的二进制发布包，二进制包在安装时相对更方便一些。</p>
<p>其中一个第三方项目是Mesosphere。按以下步骤可以安装Mesosphere提供的二进制发布包：</p>
<ol>
<li>从下载页面（<a href="http://mesosphere.io/downloads/" rel="external nofollow noreferrer">downloads page</a>）下载Mesos安装包</li>
<li>按页面上所提供的安装指令即可安装和配置Mesos</li>
</ol>
<p>Mesosphere的安装文档中建议使用Zookeeper来设置Mesos master的容错备份，但其实Mesos并不依赖于Zookeeper，可以以单master方式运行。</p>
<h2>验证</h2>
<p>接下来，需要通过浏览Mesos master的Web UI（其端口为5050）来确认一下，是否页面上slave tab显示了所有集群中的slave机器。</p>
<h1>Spark连接Mesos</h1>
<p>要在Mesos上运行Spark，你需要在Mesos能访问到的地方部署Spark的二进制包，并且需要配置一下Spark驱动程序（driver）以便使其可以连接到Mesos。</p>
<p>当然，你也可以把Spark安装到Mesos slave机器上和Mesos相同的目录下，然后配置一下spark.mesos.executor.home（默认等于${SPAKR_HOME}），使其指向这个目录。</p>
<h2>上传Spark包</h2>
<p>Mesos在某个slave机器上首次运行Spark任务的时候，slave机器上需要一个运行Spark Mesos executor backend的二进制包，这个Spark包可以放在任何能够以Hadoop兼容URL访问到的地方，包括HTTP（ <code>http://</code>, <a href="http://aws.amazon.com/s3" rel="external nofollow noreferrer">Amazon Simple Storage Service</a>）、s3n（<code>s3n://）、</code> HDFS （<code>hdfs://</code>）</p>
<p>要使用预编译好的二进制包：</p>
<ol>
<li>从这里（<a href="https://spark.apache.org/downloads.html" rel="external nofollow noreferrer">download page</a>）下载Spark二进制包</li>
<li>将Spark二进制包上传到可访问的的存储：hdfs/http/s3</li>
</ol>
<p>要存到HDFS上，可以使用Hadoop fs put 命令：hadoop fs -put spark-1.6.0.tar.gz /path/to/spark-1.6.0.tar.gz</p>
<p>或者，你也可以编译一个自定义Spark版本，可以使用Spark源码中tarball/checkout下的 make-distribution.sh脚本来打包：</p>
<ol>
<li>下载并编译Spark（参考这里<a href="http://spark.apache.org/docs/latest/index.html" rel="external nofollow noreferrer">here</a>）</li>
<li>创建一个二进制包：make-distribution.sh –tgz</li>
<li>将Spark二进制包上传到可访问的存储：hdfs/http/s3</li>
</ol>
<h2>Mesos Master URL</h2>
<p>Mesos Master URL有两种形式：</p>
<ol>
<li>单master为 mesos://host:5050</li>
<li>基于Zookeeper的多master为 mesos://zk://host:2181</li>
</ol>
<h2>客户端模式</h2>
<p>客户端模式下，客户端机器上将会启动一个Spark Mesos框架，并且会等待驱动（driver）的输出。</p>
<p>驱动需要spark-env.sh中的一些配置项，以便和Mesos交互操作：</p>
<ol>
<li>在Spark-env.sh中设置一些环境变量：</p>
<ul>
<li>export MESOS_NATIVE_JAVA_LIBRARY=&lt;path to libmesos.so&gt;。一般情况下，这个路径是 &lt;prefix&gt;/lib/libmesos.so，其中prefix的默认值是/usr/local。见前面的Mesos安装所述。在Mac OS X系统中，libmesos.so的名字变为libmesos.dylib。</li>
<li>export SPARK_EXECUTOR_URI=&lt;上文所述的上传spark-1.6.0.tar.gz对应的URL&gt;</li>
</ul>
</li>
<li>同样，spark.executor.uri 也需要设成&lt;上文所述的上传spark-1.6.0.tar.gz对应的URL&gt;</li>
</ol>
<p>然后，你就可以向这个Mesos集群提交Spark应用了，当然，你需要把Mesos Master URL（mesos:// ）传给SparkContext，例如：</p>
<pre><code>val conf = new SparkConf()
  .setMaster("mesos://HOST:5050")
  .setAppName("My app")
  .set("spark.executor.uri", "&lt;path to spark-1.6.0.tar.gz uploaded above&gt;");
val sc =newSparkContext(conf);</code></pre>
<p>（你也可以在<a href="http://spark.apache.org/docs/latest/configuration.html#loading-default-configurations" rel="external nofollow noreferrer">conf/spark-defaults.conf</a>文件中配置spark.executor.uri，然后通过 <a href="http://spark.apache.org/docs/latest/submitting-applications.html" rel="external nofollow noreferrer"><code>spark-submit</code></a> 脚本来提交Spark应用）</p>
<p>如果是在Spark shell中，spark.executor.uri参数值是从SPARK_EXECUTOR_URI继承而来的，所以不需要额外再传一个系统属性。</p>
<pre><code>./bin/spark-shell --master mesos://host:5050</code></pre>

<h2>集群模式</h2>
<p>Mesos同样也支持Spark以集群模式提交作业，这种模式下，驱动器将在集群中某一台机器上启动，其运行结果可以在Mesos Web UI上看到。</p>
<p>要使用集群模式，你首先需要利用 sbin/start-mesos-dispatcher.sh脚本启动 MesosClusterDispatcher，并且将Mesos Master URL（如：mesos://host:5050）传给该脚本。MesosClusterDispatcher启动后会以后台服务的形式运行在本机。</p>
<p>如果你想以Marathon框架运行MesosClusterDispatcher，那么就需要在前台运行MesosClusterDispatcher（如：bin/spark-class org.apache.spark.deploy.mesos.MesosClusterDispatcher）</p>
<p>客户机现在可以向Mesos集群提交任务了，如下示例，你可以用spark-submit脚本，并将master URL指定为MesosClusterDispatcher的URL（如：mesos://dispatcher:7077）。然后，你可以在Spark集群Web UI上查看驱动器程序的状态。</p>
<pre><code>./bin/spark-submit \
  --class org.apache.spark.examples.SparkPi \
  --master mesos://207.184.161.138:7077 \
  --deploy-mode cluster \
  --supervise \
  --executor-memory 20G \
  --total-executor-cores 100\
  http://path/to/examples.jar \
  1000</code></pre>
<p>注意，spark-submit中所涉及的jar包或python文件必须传到Mesos可以以URI形式访问到的位置，Spark驱动是不会自动上传任何本地jar包或python文件的。</p>
<h1>Mesos运行模式</h1>
<p>Spark可以在Mesos的两种模式下运行：“粗粒度”模式（默认）和“细粒度”模式。</p>
<p>“粗粒度”模式下，Mesos在每台机器上只启动一个长期运行的Spark任务，而Spark任务则会作为其内部的“mini-tasks”来动态调度。这样做的好处是，启动延迟会比较低，但同时，也会增加一定的资源消耗，因为Mesos需要在整个生命周期内为这些长期运行的Spark任务保留其所需的资源。</p>
<p>粗粒度是Mesos的默认模式。你也可以显示地在 <a href="http://spark.apache.org/docs/latest/configuration.html#spark-properties" rel="external nofollow noreferrer">SparkConf</a> 中设置spark.mesos.coarse属性为true来启用该模式：</p>
<pre><code>conf.set("spark.mesos.coarse","true")</code></pre>
<p>另外，在粗粒度模式下，你可以控制Spark所使用资源的上限。默认情况下，Spark会申请集群中所有的CPU（当然是Mesos所能提供的），这其实并不合理，除非你每次只启动一个应用。你可以通过SparkConf设置个帽子（上限），如：conf.set(“spark.cores.max”, “10)</p>
<p>在细粒度模式下，每个Spark任务都作为独立的Mesos任务运行。这使得多个Spark实例（或者其他计算框架）可以比较细粒度地共享机器资源，每个应用所获得的机器资源也会随着应用的启动和关闭而增加或减少，但同时每个任务的启动也会有相应的延迟。这种模式可能不适用于一些低延迟的场景，如：交互式查询，响应web请求等。</p>
<p>要使用细粒度模式，可以在<a href="http://spark.apache.org/docs/latest/configuration.html#spark-properties" rel="external nofollow noreferrer">SparkConf</a> 中将 spark.mesos.coarse 属性设为false：</p>
<pre><code>conf.set("spark.mesos.coarse","false")</code></pre>
<p>你还可以用spark.mesos.constraints属性来设置mesos资源分配约束条件。默认是没有约束的，也就是所有的资源分配都是可接受的。</p>
<pre><code>conf.set("spark.mesos.constraints","tachyon:true;us-east-1:false")</code></pre>
<p>例如，我们把spark.mesos.constraints设为tachyon:true;us-east-1:false，接下来，资源分配将会检查新分配的资源（机器）是否符合这两项约束，只有符合约束的机器才会启动新的Spark执行器（executor）。</p>
<h1>Mesos对Docker的支持</h1>
<p>Spark可以使用Mesos Docker集装箱，你需要在 <a href="http://spark.apache.org/docs/latest/configuration.html#spark-properties" rel="external nofollow noreferrer">SparkConf</a> 中设置spark.mesos.executor.docker.image属性。</p>
<p>所使用的Docker镜像必须已经包含特定的Spark版本，或者也可以使用Mesos的惯用方法下载Spark。</p>
<p>支持Docker需要Mesos 0.20.1及以上版本。</p>
<h1>和Hadoop一起运行</h1>
<p>你可以将Spark和Mesos作为机器上独立服务，和已有的Hadoop集群部署在一起。要从Spark访问Hadoop数据，需要一个完整的hdfs:// URL（通常是 hdfs://&lt;namenode&gt;:9000/path，你可以在Hadoop Namenode Web UI上看到这个URL）。</p>
<p>另外，你也可以在Mesos上运行Hadoop MapReduce，以便达到Mesos和Hadoop之间更好的资源隔离和共享。这种场景下，Mesos就是一个全局唯一的调度器，同时为Hadoop和Spark分配CPU，而不再是利用Linux调度器来共享CPU资源。更详细的请参考<a href="https://github.com/mesos/hadoop" rel="external nofollow noreferrer">Hadoop on Mesos</a>。</p>
<p>但是不管是上面哪种场景，HDFS始终是独立于Hadoop MapReduce的，也不需要Mesos的调度。</p>
<h1>Mesos中的动态资源分配</h1>
<p>Mesos在粗粒度模式下，可以支持动态分配，Mesos会基于应用的统计信息调整执行器（executor）的个数。粗粒度模式下，由于Mesos被设计成在每个slave上只启动一个执行器，所以Mesos的粗粒度调度器本身只支持减少资源分配，而动态分配同时支持减少和增加执行器的个数。所以在粗粒度调度器减少执行器个数后，如果Spark表示需要更多执行器的时候，Mesos又会重新把执行器个数提升为原值。</p>
<p>由于Mesos目前还不支持对其他框架作业终止的通知，所以想要使用动态分配这个特性的用户，需要开启Mesos Shuffle Service，来清理shuffle产生的临时数据。可以使用sbin/start-mesos-shuffle-service.sh 和 sbin/stop-mesos-shuffle-service.sh 来启动和停止Mesos Shuffle Service。</p>
<p>Shuffle Service需要在每个运行Spark执行器（executor）的节点上启动。最简单的实现方式就是在Mesos上使用Marathon启动Shuffle Service，并添加一个主机唯一的限制。</p>
<h1>配置</h1>
<p>Spark更详细的配置可参考这里：<a href="http://spark.apache.org/docs/latest/configuration.html" rel="external nofollow noreferrer">configuration page</a> 。以下为Spark on Mesos的相应配置：</p>
<h4>Spark Properties（Spark属性）</h4>
<table>
<tbody>
<tr>
<th>属性名</th>
<th>默认值</th>
<th>含义</th>
</tr>
<tr>
<td><code>spark.mesos.coarse</code></td>
<td>false</td>
<td>如果设为true，则运行于Mesos集群粗粒度模式下（<a href="http://spark.apache.org/docs/latest/running-on-mesos.html#mesos-run-modes" rel="external nofollow noreferrer">“coarse-grained” sharing mode</a>），这种模式下，Spark需要运行一个长期Mesos任务。这样可以有效减少小型查询的延迟，但同时也会增加整个Spark作业生命周期内对集群资源的占用。</td>
</tr>
<tr>
<td><code>spark.mesos.extra.cores</code></td>
<td><code>0</code></td>
<td>每一个task的额外CPU资源请求。仅在粗粒度模式下生效。每个task所申请的CPU个数 = 集群提供的个数 + 该配置所设定的个数。注意，执行器锁申请的总CPU个数不会超过 spark.cores.max</td>
</tr>
<tr>
<td><code>spark.mesos.mesosExecutor.cores</code></td>
<td><code>1.0</code></td>
<td>每个Mesos执行器的CPU个数（仅细粒度模式有效）。这不包括用于执行Spark tasks的CPU。换句话说，即使没有任何Spark任务在运行，每个Mesos执行器也会占用这么多个CPU。注意，该值可以是一个浮点数。</td>
</tr>
<tr>
<td><code>spark.mesos.executor.docker.image</code></td>
<td>(none)</td>
<td>容纳Spark执行器的docker镜像名称。这个镜像中必须包含Spark以及兼容的Mesos库。镜像中的Spark安装路径可以由spark.mesos.executor.home指定；Mesos库的安装路径可以由 spark.executor.Env.MESOS_NATIVE_JAVA_LIBRARY指定。</td>
</tr>
<tr>
<td><code>spark.mesos.executor.docker.volumes</code></td>
<td>(none)</td>
<td>设置挂载到docker镜像中的卷标（docker镜像由spark.mesos.executor.docker.image设置）。该属性值为逗号分隔的卷标路径映射列表，其格式同docker run -v所需参数，如下：</p>
<pre>[host_path:]container_path[:ro|:rw]</pre>
</td>
</tr>
<tr>
<td><code>spark.mesos.executor.docker.portmaps</code></td>
<td>(none)</td>
<td>设置docker镜像的接入端口映射列表（docker镜像由spark.mesos.executor.docker.image设置）。格式为逗号分隔的端口映射列表，如下所示：</p>
<pre>host_port:container_port[:tcp|:udp]</pre>
</td>
</tr>
<tr>
<td><code>spark.mesos.executor.home</code></td>
<td>driver side <code>SPARK_HOME<br />
驱动器所在节点上的${SPARK_HOME}</code>
</td>
<td>设置Mesos执行节点上的Spark安装目录。默认情况下，会使用驱动器（driver）所在节点的${SPARK_HOME}路径。注意，如果设置了spark.executor.uri指定Spark二进制包的位置，那么本设置将无效。</td>
</tr>
<tr>
<td><code>spark.mesos.executor.memoryOverhead</code></td>
<td>执行器内存 * 0.10 或384MB中较大者</td>
<td>每个执行器（executor）分配的额外内存总量（MB）。其默认值为 384MB或者 spark.executor.memory * 10% 二者中较大者。</td>
</tr>
<tr>
<td><code>spark.mesos.uris</code></td>
<td>(none)</td>
<td>驱动器（driver）或执行器（executor）启动时下载到沙箱中的URI列表。粗粒度和细粒度模式均适用。</td>
</tr>
<tr>
<td><code>spark.mesos.principal</code></td>
<td>(none)</td>
<td>设置Spark框架在Mesos集群上的认证身份。</td>
</tr>
<tr>
<td><code>spark.mesos.secret</code></td>
<td>(none)</td>
<td>设置Spark框架在Mesos集群上的认证密码。</td>
</tr>
<tr>
<td><code>spark.mesos.role</code></td>
<td><code>*</code></td>
<td>设置Spark框架在Mesos集群上的认证角色。角色是Mesos用于保留和分配资源的权重因子。</td>
</tr>
<tr>
<td><code>spark.mesos.constraints</code></td>
<td>(none)</td>
<td>基于资源特性的资源分配约束条件。默认，所有分配的资源都是可以接受的。更详细的资源特性请参考这里：<a href="http://mesos.apache.org/documentation/attributes-resources/" rel="external nofollow noreferrer">Mesos Attributes &amp; Resources</a></p>
<ul>
<li>数值型约束：使用”less than equal”语义，例如，约束中设置的值必须小于或等于分配资源的实际值。</li>
<li>范围型约束：使用“contains”语义，例如，约束中设置的必须包含于资源分配的实际值范围内。</li>
<li>集合型约束：使用“subset of”语义，例如，约束条件中设置的值必须是资源分配实际值的一个子集。</li>
<li>文本型约束：使用“equality”语义，例如，约束条件中的值必须精确等价月资源分配中的值。</li>
<li>如果资源的所有特性都没有对应的约束条件中，则该资源是可接受的（即不需要检查）</li>
</ul>
</td>
</tr>
</tbody>
</table>
<h1>排错和调试</h1>
<p>调试时需要关注的地方：</p>
<ul>
<li><code>Mesos master（端口：5050）</code></p>
<ul>
<li>Slave节点应该全部显示在slaves tab页上</li>
<li>Spark应用应该显示在frameworks tab页上</li>
<li>Spark任务应该显示在framework detail中</li>
<li>检查失败任务沙箱的标准输出和标准错误</li>
</ul>
</li>
<li>Mesos日志
<ul>
<li>默认，master和slave的日志都保存在/var/log/mesos目录下</li>
</ul>
</li>
</ul>
<p>常见陷阱：</p>
<ul>
<li>Spark程序集不可访问</p>
<ul>
<li>Slave机器必须能够通过你指定的http://, hdfs:// 或者 s3n:// 等URL访问并下载Spark的二进制包</li>
</ul>
</li>
<li>防火墙阻断网络通信
<ul>
<li>检查是否有连接失败消息</li>
<li>临时关闭防火墙以便调试，后续再专门放开几个端口</li>
<li>转载自 <a href="http://ifeve.com/" rel="external nofollow noreferrer">并发编程网 - ifeve.com</a></li>
</ul>
</li>
</ul>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:23:14</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e9%9b%86%e7%be%a4/" title="集群">集群</a>, <a href="https://www.iamivan.net/tag/%e9%95%9c%e5%83%8f/" title="镜像">镜像</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/url/" title="url">url</a>, <a href="https://www.iamivan.net/tag/%e8%84%9a%e6%9c%ac/" title="脚本">脚本</a>, <a href="https://www.iamivan.net/tag/hadoop/" title="hadoop">hadoop</a>, <a href="https://www.iamivan.net/tag/docker/" title="docker">docker</a>, <a href="https://www.iamivan.net/tag/spark/" title="spark">spark</a>, <a href="https://www.iamivan.net/tag/mesos/" title="Mesos">Mesos</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《Spark 官方文档》在Mesos上运行Spark的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6YXJob.html" rel="bookmark">《Spark 官方文档》</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spark是一个高效的分布式计算系统,本文是Spark官方文档的翻译. 编程指南: 快速入门 编程指南 在Spark里构建模块 Spark Streaming编程 Spark SQL, DataFrames 以及 Datasets 编程指南 机器学习库MLlib GraphX: Spark's new API for graph processing API文档: Spark Scala API (Scaladoc) Spark Java API (Javadoc) Spark Python A			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pX0KeAp.html" rel="bookmark">《Spark官方文档》Spark操作指南</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文链接   译者:小村长 Spark–Quick Start 本项目是 Apache Spark官方文档的中文翻译版,致力于打造一个全新的大数据处理平台来满足大数据处理和分析的各个使用场景,本次翻译主要针对对Spark感兴趣和致力于从事大数据方法开发的人员提供有价值的中文资料,希望能够对大家的工作和学习有所帮助. Spark最近几年在国内外都比较火,在淘宝.百度.腾讯.高伟达等一些公司有比较成熟的应用,做大数据方面的开发人员或多或少都与其有接触.Spark的中文资料相对前几年相对较多,但是我认			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvY07Ab.html" rel="bookmark">Spark学习之在集群上运行Spark（6）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spark学习之在集群上运行Spark(6) 1. Spark的一个优点在于可以通过增加机器数量并使用集群模式运行,来扩展程序的计算能力. 2. Spark既能适用于专用集群,也可以适用于共享的云计算环境. 3. Spark在分布式环境中的架构: Created with Raphaël 2.1.0我的操作集群管理器Mesos.YARN.或独立集群管理器N个集群工作节点(执行器进程) Spark集群采用的是主/从结构,驱动器(Driver)节点和所有执行器(executor)节点一起被称为一个S			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNnJPyM.html" rel="bookmark">《Spark 官方文档》在YARN上运行Spark</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在YARN上运行Spark 对 YARN (Hadoop NextGen) 的支持是从Spark-0.6.0开始的,后续的版本也一直持续在改进. 在YARN上启动 首先确保 HADOOP_CONF_DIR 或者 YARN_CONF_DIR 变量指向一个包含Hadoop集群客户端配置文件的目录.这些配置用于读写HDFS和连接YARN资源管理器(ResourceManager).这些配置应该发布到YARN集群上所有的节点,这样所有的YARN容器才能使用同样的配置.如果这些配置引用了Java系统属性或			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJkaB4b.html" rel="bookmark">《Spark官方文档》在YARN上运行Spark</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spark在 0.6.0版本后支持在YARN(hadoop NextGen)上运行,并且在后续版本中不断改进. 在YARN上启动Spark 首先,确认 HADOOP_CONF_DIR或YARN_CONF_DIR指向的包含了Hadoop集群的配置文件.这些配置用于操作HDFS和连接YARN资源管理器.在这个目录下的这些配置文件将被分发到YARN集群中,因此应用所使用的容器能够使用相同的配置.如果配置中的java系统参数或环境变量没有被YARN所管理,就必须设置在Spark应用的配置中(驱动.执行器			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvqKD6b.html" rel="bookmark">《Spark 官方文档》在Amazon EC2上运行Spark</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Amazon EC2上运行Spark Spark的ec2目录下有一个spark-ec2脚本,可以帮助你在Amazon EC2上启动.管理.关闭Spark集群.该脚本能在EC2集群上自动设置好Spark和HDFS.本文将会详细描述如何利用spark-ec2脚本来启动和关闭集群,以及如何在集群提交作业.当然,首先你必须在Amazon Web Services site上注册一个EC2的账户.   spark-ec2可以管理多个命名集群.你可以用它来启动一个新集群(需要提供集群大小和集群名称),关闭			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrW40xp.html" rel="bookmark">《Spark官方文档》Spark Streaming编程指南（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spark Streaming编程指南 概览   Spark Streaming是对核心Spark API的一个扩展,它能够实现对实时数据流的流式处理,并具有很好的可扩展性.高吞吐量和容错性.Spark Streaming支持从多种数据源提取数据,如:Kafka.Flume.Twitter.ZeroMQ.Kinesis以及TCP套接字,并且可以提供一些高级API来表达复杂的处理算法,如:map.reduce.join和window等.最后,Spark Streaming支持将处理完的数据推送到文			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0QJvnp.html" rel="bookmark">《Spark 官方文档》Spark编程指南</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spark编程指南 概述 总体上来说,每个Spark应用都包含一个驱动器(driver)程序,驱动器运行用户的main函数,并在集群上执行各种并行操作. Spark最重要的一个抽象概念就是弹性分布式数据集(resilient distributed dataset – RDD),RDD是一个可分区的元素集合,其包含的元素可以分布在集群各个节点上,并且可以执行一些分布式并行操作.RDD通常是通过,HDFS(或者其他Hadoop支持的文件系统)上的文件,或者驱动器中的Scala集合对象,来创建或转换			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJkWA7b.html" rel="bookmark">《Spark官方文档》Spark Streaming编程指南（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				累加器和广播变量 首先需要注意的是,累加器(Accumulators)和广播变量(Broadcast variables)是无法从Spark Streaming的检查点中恢复回来的.所以如果你开启了检查点功能,并同时在使用累加器和广播变量,那么你最好是使用懒惰实例化的单例模式,因为这样累加器和广播变量才能在驱动器(driver)故障恢复后重新实例化.代码示例如下: Scala Java Python object WordBlacklist { @volatile private var ins			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQPQWz.html" rel="bookmark" class="title">markdown使用基本语法</a>
					<div>
						### 1. 斜体和粗体 使用 * 和 ** 表示斜体和粗体. 示例: 这是 *斜体*,这是 **粗体**. ### 2. 分级标题 使用 === 表示一级标题,使用 --- 表示二级标题. 示例:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPld8p.html" rel="bookmark" class="title">浅谈网页设计中的简约之美</a>
					<div>
						  随着网页技术的不断发展,网页设计的趋势在改变,扁平化.响应式.视觉差滚动.卡片式等给设计师带来了更多的发挥空间.简约的设计,也以其简洁直观.轻薄美观等特点,越来越受到设计师的追捧和大众的喜爱. 那 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBXEKp.html" rel="bookmark" class="title">防止垃圾广告和盗链的新方法</a>
					<div>
						前天晚上,我遭到了垃圾留言广告的袭击. 晚上我刚去打了2个小时游戏,就有人用程序狂灌我几百个垃圾留言广告.这时我也发现目前的防垃圾留言系统存在漏洞,那个发广告的家伙先用程序伪造了refer,然后每篇文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmXZlM.html" rel="bookmark" class="title">Check Point防火墙助电信企业构建安全网络</a>
					<div>
						该家大型电信服务运营商为户提供不可或缺的电信.通信及信息服务,为了保证服务的水平,其运营系统的稳定性.可靠性和安全性有着过硬的要求,以安全性为例,其电信数据通信网络(DCN) 便采用了在互联网安全领域 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJGY4b.html" rel="bookmark" class="title">数据库Identity&plus;Primarykey字段强行插入的处理</a>
					<div>
						插入|数据|数据库 由于是Identity,所以在强行插入的时候需要将identity属性丢弃,插入后再将identity属性拾回.做下面的操作 SET IDENTITY_INSERT [TABLEN ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeyrNz.html" rel="bookmark" class="title">Photoshop外挂滤镜</a>
					<div>
						滤镜 滤镜(Filter)作为第三方插件(Plug-in)加进到Photoshop.ImageRready.PaintPro等图片软件中,以产生特别效果.某些滤镜可通用于各种图像处理软件,但这要似乎插 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbaJQwM.html" rel="bookmark" class="title">J2ME 2D小游戏入门之旅&lpar;七&rpar; 不足多多，你认为呢？</a>
					<div>
						七.不足多多,你认为呢? 游戏已经成型了,冲杯咖啡犒劳一下自己吧.呵呵还是算了,咖啡因对下一代不好. 当你看完以上的所有,你有什么想法呢?不要说没有.你一定是像我一样揣着一份完成clone作品的兴奋和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJ8DqM.html" rel="bookmark" class="title">PS教程：调制人物的亮丽质感肤色</a>
					<div>
						人物脸部有点暗.处理的时候先把人物脸部调亮,然后适当给人物磨皮及消除斑点.为了保持人物肤色的质感,最后需要用滤镜来制作人物脸部的毛孔. 原图素材有点背光,人物脸部有点暗.处理的时候先把人物脸部调亮,然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlqORp.html" rel="bookmark" class="title">继百度首页改版后关于添加按钮的实例分析</a>
					<div>
						2012.5.16日百度进行了首页的改版,如下图图一.   继2012.5.17日之后的星期四到星期五的更新,百度部分网站出现了添加到首页更能的按钮,如图二.当我搜索部分关键词,反馈的结果在第一位的会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNo0lb.html" rel="bookmark" class="title">探讨对称性交互应用</a>
					<div>
						在界面设计中,对称性的信息呈现方式非常普遍,信息等价并且均匀分布在规则的几何图形周边能带来和谐的比例与平衡.在交互设计过程中,让用户的操作流也以对称性的方式完成,我们称之为对称性交互(Symmetry ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oWZBb.html" rel="bookmark" class="title">如何用Excel Vlookup批量调整工资表</a>
					<div>
						  现在有一张清单,其中只列出了要调整工资人员的名单和具体调资金额,要求必须按清单从工资表中查找相应的人员记录逐一修改工资.如果按一般方法逐一查找修改,这几十个人逐一改下来可不轻松.其实借用一下Exc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWX6JGp.html" rel="bookmark" class="title">金山快盘怎么把协作给到别人</a>
					<div>
						  金山快盘如何使用协作功能?金山快盘怎么把协作给到别人呢?小编今天教你玩转金山快盘文件夹的协作功能 首先在电脑上必须安装金山快盘客户端.然后使用相应的账号进行登陆.   打开金山网盘文件夹,点击要进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArmRKp.html" rel="bookmark" class="title">Windows Server2008禁用本地端口</a>
					<div>
						  Windows Server 2008禁用本地端口 Windows系统默认情况下很多端口都是开放的.通过关闭某些端口,可以在一定程度上提高Windows系统的安全性,特别是对于服务器来说. 通过命 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOaL83M.html" rel="bookmark" class="title">比较实用的正则表达式学习笔记&lowbar;正则表达式</a>
					<div>
						//匹配文本,这个偶尔比较好用,但是要小心字符中包含\E $str = '[a-z]'; $str = preg_replace('/\G[a-z]\E/', '', $str); echo $str ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bam1Awb.html" rel="bookmark" class="title">ug编程-谁有UG后处理构造器   是UG8&period;0的</a>
					<div>
						问题描述 谁有UG后处理构造器 是UG8.0的 谁有UG后处理构造器 是UG8.0的 谁有UG后处理构造器 是UG8.0的 谁有UG后处理构造器 是UG8.0的 谁有UG后处理构造器 是UG8.0的  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lJZjb.html" rel="bookmark" class="title">怎么在代码里判断当前是调试运行（F5）还是不调试直接运行（Ctrl&plus;F5）呢？</a>
					<div>
						问题描述 怎么在代码里判断当前是调试运行(F5)还是不调试直接运行(Ctrl+F5)呢? 解决方案 解决方案二:一般用System.Diagnostics.Debug.Write来输出调试信息就行了, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxoR67b.html" rel="bookmark" class="title">100&sol;200主板装Windows 7 看这5张图就行</a>
					<div>
						Windows10好用的很,不过有些同学不喜欢,这周留言里的问题有不少人还在纠结这个事情,尤其是准备升级电脑,又不想换Windows10的人都在提问,小编今天就给大家分享一下,在使用100/200系列 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjPoQp.html" rel="bookmark" class="title">关于listview为新对象添加图标的问题（不急）</a>
					<div>
						问题描述 刚刚开始学C#,遇到一个问题,搞不大明白,就是为listview新添加的对象旁边添加一个图标,事先声明一下,我真的很菜--请各位不吝赐教啊,多多指点,谢谢谢谢!namespace_11._8 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXgvvz.html" rel="bookmark" class="title">用bat实现删除系统脚本调试程序&lowbar;DOS&sol;BAT</a>
					<div>
						删除一些危险的对象,从根本上解决问题.这些对象对普通用户是没什么用的. 1)禁用WSHShell对象,阻止运行程序. 删除或更名系统文件夹中的wshom.ocx 或删除注册表项: HKEY_LOCAL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Z7QAz.html" rel="bookmark" class="title">解决Dedecms输入网址跳转的方法</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 各位站长朋友大家好.今天发篇文章为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Jjmgz.html" rel="bookmark" class="title">linux下mysql5&period;5&period;15源码包编译安装</a>
					<div>
						原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://navyaijm.blog.51cto.com/4647068/809416 my ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqGQ8p.html" rel="bookmark" class="title">请教一个引用DLL中组件的问题</a>
					<div>
						问题描述 VS2008,改造一个C#项目,由于要使用DLL中的多个组件,DLL已经引用进项目,而且前期项目已经使用了其中的两个组件,但其他的组件现在却无法再添加到窗体,在工具箱中右键添加项,几种方式都 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5RXdp.html" rel="bookmark" class="title">网站备案之殇 站长备案你受伤了吗</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 大家好,我是木子成舟.前段时间我有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0nyEAz.html" rel="bookmark" class="title">史上最简单的软件破解&mdash;&mdash;5行脚本代码完美破解99&percnt;的过期软件</a>
					<div>
						       如果你看到了这篇博文,绝对保证不虚此行.仅仅5行脚本代码,即可破解99%的过期软件.          这件事的背景:最近在找了一些学习资料,其中有Rational Rose画的图,好久 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0k8QM.html" rel="bookmark" class="title">关于类的继承问题，子类如何赋值？</a>
					<div>
						问题描述 classaa{publicstringxx;}classbb:aa{publicbb(){}publicbb(aat){//怎么把t的值赋到bb里呢?//this.xx=t.xx不要这种方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1Keob.html" rel="bookmark" class="title">三大UML建模工具Visio、Rational Rose、PowerDesign的区别比较&lowbar;相关技巧</a>
					<div>
						ROSE是直接从UML发展而诞生的设计工具,它的出现就是为了对UML建模的支持,ROSE一开始没有对数据库端建模的支持,但是在现在的版本中已经加入数据库建模的功能.ROSE主要是在开发过程中的各种语义 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEoxEz.html" rel="bookmark" class="title">python 根据正则表达式提取指定的内容实例详解&lowbar;python</a>
					<div>
						python 根据正则表达式提取指定的内容 正则表达式是极其强大的,利用正则表达式来提取想要的内容是很方便的事.   下面演示了在python里,通过正则表达式来提取符合要求的内容. 实例代码: im ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLPP3M.html" rel="bookmark" class="title">Android自定义控件之仿优酷菜单&lowbar;Android</a>
					<div>
						去年的优酷HD版有过这样一种菜单,如下图: 应用打开之后,先是三个弧形的三级菜单,点击实体键menu之后,这三个菜单依次旋转退出,再点击实体键menu之后,一级菜单会旋转进入,点击一级菜单,二级菜单旋 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Qo4XM.html" rel="bookmark" class="title">jquery笔记之点击按钮隐藏标签和显示标签</a>
					<div>
						 代码如下 复制代码 &lt;meta content=&quot;text/html; charset=utf-8&quot; http-equiv=&quot;Content-Type&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7QraAM.html" rel="bookmark" class="title">json转换问题</a>
					<div>
						问题描述 碰到了一个json转换的问题,以下是测试代码:List list = new ArrayList(); list.add( &quot;first&quot; ); list.add( &q ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
